moDraw.mohSLOT= {};

function moDraw.mohSLOT:setOpenDrawGen1(self, whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	moGeneralSettings.clickAreas.slot[whichSubSLOT] = {};
	local horizontal = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].width;
	local vertical = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].height;
	local posX = moSetGetOverlays.slot[whichSubSLOT].manuPosX or moSetGetOverlays.slot[whichSubSLOT].pos.x;
	local posY = moSetGetOverlays.slot[whichSubSLOT].manuPosY or moSetGetOverlays.slot[whichSubSLOT].pos.y;
	local height = moSetGetOverlays.slot[whichSubSLOT].height;
	local width = moSetGetOverlays.slot[whichSubSLOT].width;
	local txtHeight = moSetGetOverlays.slot[whichSubSLOT].txtHeight;
	local size = moSetGetOverlays.slot[whichSubSLOT].size;
	local horizontalTxtDistance = moSetGetOverlays.slot[whichSubSLOT].horizontalTxtDistance;
	local verticalTxtDistance = moSetGetOverlays.slot[whichSubSLOT].verticalTxtDistance;
	local masterHeight = (vertical*2)+txtHeight+verticalTxtDistance;
	local disableClickArea = MultiOverlayV3.dragDropPos.on;
	local overlay = moSetGetOverlays.slot[whichSubSLOT].design;
	local slotTable = moSetGetOverlays.slot[whichSubSLOT];
	local newPosX = 0;
	local newPosY = 0;
	local txt = "";
	local optiSize = 0;
	local txtLength = 0;
	local txtWidth = 0;	
	
	-------dragDrop action-------
	if MultiOverlayV3.dragDropPos.on and MultiOverlayV3.dragDropPos.whatDragDrop == whichSubSLOT then
		if MultiOverlayV3.dragDropPos.whereDragDrop == "widthHeightZoomSlot" then
			local tempWidth = MultiOverlayV3.mouseCursor.posX-posX;
			local tempHeight = posY-MultiOverlayV3.mouseCursor.posY;
			if tempWidth > slotTable.defaultWidth then
				slotTable.width = tempWidth;				
			end;
			if tempHeight > slotTable.defaultHeight then
				slotTable.height = tempHeight;				
			end;
			moSetGetMohSLOT:resetRenderViewText(whichSubSLOT);
			moSetGetMohSLOT:resetRenderViewLines(whichSubSLOT);
			slotTable.save = false;
		elseif MultiOverlayV3.dragDropPos.whereDragDrop == "slideLeftRightRegulatorSlot" then			
			local flickerDif = 0.002; --prevent flickering, test --> eventuell anders lösen
			local mousePosX = MultiOverlayV3.mouseCursor.posX;			
			local tempPosX = overlay["slideLeftRightRegulator"].x+(overlay["slideLeftRightRegulator"].width/2)
			if mousePosX > posX and mousePosX < posX+width then
				if mousePosX > tempPosX+flickerDif then 
					moSetGetMohSLOT:setRenderViewText(whichSubSLOT, true);
				elseif mousePosX < tempPosX-flickerDif then
					moSetGetMohSLOT:setRenderViewText(whichSubSLOT, false);
				end;				
			end;
			slotTable.save = false;
		else	
			slotTable.manuPosX = MultiOverlayV3.mouseCursor.posX;
			slotTable.manuPosY = MultiOverlayV3.mouseCursor.posY-masterHeight;
			slotTable.save = false;
		end;
	end;	
	-------dragDrop action-------
	
	--------------------------masterGround--------------------------
	moSetGetOverlays:setOverlay(self, overlay["groundMaster"], posX, posY, width, masterHeight);
	overlay["groundMaster"]:render();
	--dragDrop
	moSetGetOverlays:setOverlay(self, overlay["dragDrop"], posX, posY+masterHeight-vertical);
	if not MultiOverlayV3.dragDropPos.on then moSetGetOverlays:setBackgroundColor(overlay["dragDrop"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["dragDrop"], moColors.intern["red"]);end;
	if not MultiOverlayV3.dragDropPos.on or MultiOverlayV3.dragDropPos.whatDragDrop == whichSubSLOT then moDraw.mohSLOT:clickAreas(overlay["dragDrop"].x, overlay["dragDrop"].x+overlay["dragDrop"].width, overlay["dragDrop"].y, overlay["dragDrop"].y+overlay["dragDrop"].height, "dragDrop", whichSubSLOT);end;
	overlay["dragDrop"]:render();
	--dragDrop
	--setting	
	moSetGetOverlays:setOverlay(self, overlay["setting"], posX+horizontal, posY+masterHeight-vertical);
	if slotTable.setting.on then 
		moSetGetOverlays:setBackgroundColor(overlay["setting"], moColors.intern["green"]);
	else
		moSetGetOverlays:setBackgroundColor(overlay["setting"], moColors.intern["darkGray"]);
	end;
	overlay["setting"]:render();
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["setting"].x, overlay["setting"].x+overlay["setting"].width, overlay["setting"].y, overlay["setting"].y+overlay["setting"].height, "settingSlot", whichSubSLOT);end;
	--setting
	--save
	moSetGetOverlays:setOverlay(self, overlay["save"], posX+(horizontal*2), posY+masterHeight-vertical);
	if slotTable.save then moSetGetOverlays:setBackgroundColor(overlay["save"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["save"], moColors.intern["red"]);end;
	overlay["save"]:render();
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["save"].x, overlay["save"].x+overlay["save"].width, overlay["save"].y, overlay["save"].y+overlay["save"].height, "saveSlot", whichSubSLOT);end;
	--save
	--help
	moSetGetOverlays:setOverlay(self, overlay["help"], posX+width-(horizontal*3), posY+masterHeight-vertical);
	moSetGetOverlays:setBackgroundColor(overlay["help"], moColors.intern["yellow"]);
	overlay["help"]:render();
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["help"].x, overlay["help"].x+overlay["help"].width, overlay["help"].y, overlay["help"].y+overlay["help"].height, "visibleOwnHelpSlot", whichSubSLOT);end;
	--help	
	--smallView
	moSetGetOverlays:setOverlay(self, overlay["smallView"], posX+width-(horizontal*2), posY+masterHeight-vertical);	
	if not moSetGetOverlays.slot[whichSubSLOT].smallView then moSetGetOverlays:setBackgroundColor(overlay["smallView"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["smallView"], moColors.intern["red"]);end;
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["smallView"].x, overlay["smallView"].x+overlay["smallView"].width, overlay["smallView"].y, overlay["smallView"].y+overlay["smallView"].height, "smallViewSlot", whichSubSLOT);end;
	overlay["smallView"]:render();
	--smallView
	--close
	moSetGetOverlays:setOverlay(self, overlay["close"], posX+width-horizontal, posY+masterHeight-vertical);
	overlay["close"]:render();
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["close"].x, overlay["close"].x+overlay["close"].width, overlay["close"].y, overlay["close"].y+overlay["close"].height, "closeSlot", whichSubSLOT);end;
	--close	
	--edit txt
	local txtEdit = 0;
	if slotTable.setting.on then 
		txtEdit = horizontal;
		moSetGetOverlays:setOverlay(self, overlay["txtEdit"], posX, posY+masterHeight-vertical-txtHeight+verticalTxtDistance);
		if moSetGetExtras:runsTimer("1sec", true) then
			if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["txtEdit"].x, overlay["txtEdit"].x+overlay["txtEdit"].width, overlay["txtEdit"].y, overlay["txtEdit"].y+overlay["txtEdit"].height, "txtEditNameSlot", whichSubSLOT);end;
			overlay["txtEdit"]:render();
		end;
	end;
	--edit txt
	--txt
	txt = tostring(slotTable.name);
	optiSize = moSetGetExtras:getWidthOptimalSize(width-txtEdit, txt, slotTable.size);	
	setTextBold(true);
	setTextColor(unpack(moColors.extern[slotTable.txtColor]));
	renderText(overlay["groundMaster"].x+horizontalTxtDistance+txtEdit, posY+masterHeight-vertical-txtHeight+0.001, optiSize, txt);
	setTextBold(false);
	setTextColor(1, 1, 1, 1);
	--txt
	--slideRegulator/move txt
	moSetGetOverlays:setOverlay(self, overlay["slideLeftRightGround"], posX, posY, width, vertical);
	overlay["slideLeftRightGround"]:render();
	moDraw.mohSLOT:setLineBorder(self, overlay["line"], overlay["slideLeftRightGround"], 1, 0.0005, true, true, true, true, moColors.intern["black"]);	
	--move text
	if not slotTable.smallView then 
		
	end;
	--move text
	--slideRegulator/move text
	--------------------------masterGround--------------------------
	
	if not moSetGetOverlays.slot[whichSubSLOT].smallView then
		--------------------------slave Ground--------------------------		
		moSetGetOverlays:setOverlay(self, overlay["groundLines"], posX, posY-height, width, vertical);
		moSetGetOverlays:setOverlay(self, overlay["groundSlave"], posX, posY-height, width, height);		
		overlay["groundSlave"]:render();
		--slotHelp by lineTable
		moSetGetOverlays:setOverlay(self, overlay["help"], posX+width-(horizontal*4), posY+masterHeight-vertical);
		if slotTable.isLineHelp then moSetGetOverlays:setBackgroundColor(overlay["help"], moColors.intern["green"]);else	moSetGetOverlays:setBackgroundColor(overlay["help"], moColors.intern["red"]);end;
		overlay["help"]:render();
		if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["help"].x, overlay["help"].x+overlay["help"].width, overlay["help"].y, overlay["help"].y+overlay["help"].height, "slotLineHelp", whichSubSLOT);end;
		--slotHelp by lineTable		
		--widthHeightZoom
		if not MultiOverlayV3.dragDropPos.on and overlay["widthHeightZoom"].visible and not moSetGetExtras:runsTimer("5sec") then overlay["widthHeightZoom"].visible = false;end;
		moSetGetOverlays:setOverlay(self, overlay["widthHeightZoom"], posX+width-(horizontal/1.5), overlay["groundSlave"].y-(vertical/2.5));
		overlay["widthHeightZoom"]:render();		
		if not MultiOverlayV3.dragDropPos.on or MultiOverlayV3.dragDropPos.whatDragDrop == whichSubSLOT then moDraw.mohSLOT:clickAreas(overlay["widthHeightZoom"].x, overlay["widthHeightZoom"].x+overlay["widthHeightZoom"].width, overlay["widthHeightZoom"].y, overlay["widthHeightZoom"].y+overlay["widthHeightZoom"].height, "widthHeightZoomSlot", whichSubSLOT);end;
		--widthHeightZoom
		--slideRegulator/Buttons
		if overlay["slideLeftRightGround"].slideTable == nil or disableClickArea then moDraw.mohSLOT:getSlideRegulatorOverlay(false, 0.0008, whichSubSLOT);end;		
		if moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[4] then
			moDraw.mohSLOT:setSlideRegulatorOverlay(self, overlay["slideLeftRightRegulator"], overlay["slideLeftRightGround"].slideTable, moColors.intern["whiteDisabled"]);
			moDraw.mohSLOT:setSlideButtonOverlay(self, overlay["slideLeftRightGround"], false, nil, whichSubSLOT);
			moDraw.mohSLOT:setLineBorder(self, overlay["line"], overlay["slideButtonLeft"], 1, 0.0005, false, false, false, true, nil);
			moDraw.mohSLOT:setLineBorder(self, overlay["line"], overlay["slideButtonRight"], 1, 0.0005, false, false, true, false, nil);
			if not disableClickArea then
				moDraw.mohSLOT:clickAreas(overlay["slideButtonLeft"].x, overlay["slideButtonLeft"].x+overlay["slideButtonLeft"].width, overlay["slideButtonLeft"].y, overlay["slideButtonLeft"].y+overlay["slideButtonLeft"].height, "slideButtonLeftSlot", whichSubSLOT);
				moDraw.mohSLOT:clickAreas(overlay["slideButtonRight"].x, overlay["slideButtonRight"].x+overlay["slideButtonRight"].width, overlay["slideButtonRight"].y, overlay["slideButtonRight"].y+overlay["slideButtonRight"].height, "slideButtonRightSlot", whichSubSLOT);
				moDraw.mohSLOT:clickAreas(overlay["slideLeftRightGround"].x, overlay["slideLeftRightGround"].x+overlay["slideLeftRightGround"].width, overlay["slideLeftRightGround"].y, overlay["slideLeftRightGround"].y+overlay["slideLeftRightGround"].height, "scrollSlideLeftRightSlot", whichSubSLOT);
				moDraw.mohSLOT:clickAreas(overlay["slideLeftRightRegulator"].x, overlay["slideLeftRightRegulator"].x+overlay["slideLeftRightRegulator"].width, overlay["slideLeftRightRegulator"].y, overlay["slideLeftRightRegulator"].y+overlay["slideLeftRightRegulator"].height, "slideLeftRightRegulatorSlot", whichSubSLOT);
			end;
		end;
		--slideRegulator/Buttons
		--------------------------slave Ground--------------------------		
		if not slotTable.setting.on and slotTable.cmd ~= nil and #slotTable.cmd > 0 then
			local maxLines = 0;
			local acceptCmdTyp = moGeneralSettings.acceptCmdTyp;			
			local cmdExecuted = 0;
			local nextCmd = 1;
			for cmd=1, #slotTable.cmd do				
				if slotTable.cmd[cmd] ~= nil then					
					local slotCmdTable = slotTable.cmd[cmd]					
					local getCmdName = slotCmdTable.name;
					local getCmdFrom = slotCmdTable.from;
					local getCmdFromRealName = slotCmdTable.fromRealName;
					local getCmdTable = moSetGetCmd:cmdFromReady(nil, getCmdName, getCmdFrom, getCmdFromRealName);					
					if getCmdTable ~= nil and string.find(acceptCmdTyp, getCmdTable.typ) and getCmdTable.typ == "output_" then						
						if not getCmdTable.multiple and cmdExecuted > 0 then return;end; --not multiple cmd, here stop
						if type(getCmdTable.action) == "function" then							
							local getOutputLineTable = getCmdTable.action(getCmdTable);							
							if getOutputLineTable ~= nil and type(getOutputLineTable) == "table" and #getOutputLineTable > 0 then
								if slotTable.output[nextCmd] == nil then slotTable.output[nextCmd] = {line={}};end;
								slotTable.output[nextCmd].line = getOutputLineTable;							
								maxLines = maxLines+#slotTable.output[nextCmd].line;
								cmdExecuted = cmdExecuted+1;
								nextCmd = nextCmd+1; --for old other Maps Cmds								
							end;
						end;						
					end;
				end;
			end;
			if cmdExecuted > 0 then				
				local outputTable = slotTable.output;
				slotTable.renderViewLines.bounds[3] = maxLines;
				moDraw.type:setOpenDraw_TypeNew( {posX=posX,posY=posY,height=height,width=width,txtHeight=txtHeight,size=size,overlay=overlay,outputTable=outputTable,slotTable=slotTable,horizontal=horizontal,horizontalTxtDistance=horizontalTxtDistance,vertical=vertical,verticalTxtDistance=verticalTxtDistance,masterHeight=masterHeight,disableClickArea=disableClickArea,whichSubSLOT=whichSubSLOT} )
			end;			
		elseif slotTable.setting.on then			
			slotOutputTables:loadSlotOutputCmd(whichSubSLOT);			
			slotTable.output = {};
			slotTable.output[1] = {line=slotTable.setting.output};			
			local outputTable = slotTable.output;				
			slotTable.renderViewLines.bounds[3] = #slotTable.output[1].line;			
			moDraw.type:setOpenDraw_TypeNew( {posX=posX,posY=posY,height=height,width=width,txtHeight=txtHeight,size=size,overlay=overlay,outputTable=outputTable,slotTable=slotTable,horizontal=horizontal,horizontalTxtDistance=horizontalTxtDistance,vertical=vertical,verticalTxtDistance=verticalTxtDistance,masterHeight=masterHeight,disableClickArea=disableClickArea,whichSubSLOT=whichSubSLOT} )
		end;
		if not disableClickArea then --scrollSlideUpDownSlot
			moDraw.mohSLOT:clickAreas(overlay["groundSlave"].x, overlay["groundSlave"].x+overlay["groundSlave"].width, overlay["groundSlave"].y, overlay["groundSlave"].y+overlay["groundSlave"].height, "scrollSlideUpDownSlot", whichSubSLOT);
		end;
	end;
	setTextBold(false);
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
end;

function moDraw.mohSLOT:setOpenDrawGen2(self, whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	moGeneralSettings.clickAreas.slot[whichSubSLOT] = {};
	local horizontal = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].width;
	local vertical = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].height;
	local posX = moSetGetOverlays.slot[whichSubSLOT].manuPosX or moSetGetOverlays.slot[whichSubSLOT].pos.x;
	local posY = moSetGetOverlays.slot[whichSubSLOT].manuPosY or moSetGetOverlays.slot[whichSubSLOT].pos.y;
	local height = moSetGetOverlays.slot[whichSubSLOT].height;
	local width = moSetGetOverlays.slot[whichSubSLOT].width;
	local txtHeight = moSetGetOverlays.slot[whichSubSLOT].txtHeight;
	local size = moSetGetOverlays.slot[whichSubSLOT].size;
	local horizontalTxtDistance = moSetGetOverlays.slot[whichSubSLOT].horizontalTxtDistance;
	local verticalTxtDistance = moSetGetOverlays.slot[whichSubSLOT].verticalTxtDistance;
	local lineDistance = moSetGetOverlays.slot[whichSubSLOT].lineDistance;
	local masterHeight = (vertical*1)+(lineDistance*1);
	local slotTable = moSetGetOverlays.slot[whichSubSLOT];
	if slotTable.settingLine then masterHeight = (vertical*2)+(lineDistance*2);posY=posY-vertical;end;
	local disableClickArea = MultiOverlayV3.dragDropPos.on;
	local overlay = moSetGetOverlays.slot[whichSubSLOT].design;	
	local newPosX = 0;
	local newPosY = 0;
	local txt = "";
	local optiSize = 0;
	local txtLength = 0;
	local txtWidth = 0;	
	
	-------dragDrop action-------
	if MultiOverlayV3.dragDropPos.on and MultiOverlayV3.dragDropPos.whatDragDrop == whichSubSLOT then
		if MultiOverlayV3.dragDropPos.whereDragDrop == "widthHeightZoomSlot" then
			local tempWidth = MultiOverlayV3.mouseCursor.posX-posX;
			local tempHeight = posY-MultiOverlayV3.mouseCursor.posY;
			if tempWidth > slotTable.defaultWidth then
				slotTable.width = tempWidth;				
			end;
			if tempHeight > slotTable.defaultHeight then
				slotTable.height = tempHeight;				
			end;
			moSetGetMohSLOT:resetRenderViewText(whichSubSLOT);
			moSetGetMohSLOT:resetRenderViewLines(whichSubSLOT);
			slotTable.save = false;		
		else	
			slotTable.manuPosX = MultiOverlayV3.mouseCursor.posX-(horizontal/2);
			slotTable.manuPosY = MultiOverlayV3.mouseCursor.posY+(vertical/2);
			slotTable.save = false;
		end;
	end;	
	-------dragDrop action-------
	
	--master ground
	moSetGetOverlays:setOverlay(self, overlay["groundMaster"], posX, posY, width, masterHeight);
	overlay["groundMaster"]:render();
	--master ground
	--settingLine
	if slotTable.settingLine then
		--dragDrop
		moSetGetOverlays:setOverlay(self, overlay["dragDrop"], posX, posY);
		if not MultiOverlayV3.dragDropPos.on then moSetGetOverlays:setBackgroundColor(overlay["dragDrop"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["dragDrop"], moColors.intern["red"]);end;
		if not MultiOverlayV3.dragDropPos.on or MultiOverlayV3.dragDropPos.whatDragDrop == whichSubSLOT then moDraw.mohSLOT:clickAreas(overlay["dragDrop"].x, overlay["dragDrop"].x+overlay["dragDrop"].width, overlay["dragDrop"].y, overlay["dragDrop"].y+overlay["dragDrop"].height, "dragDrop", whichSubSLOT);end;
		overlay["dragDrop"]:render();
		--dragDrop
		--setting	
		moSetGetOverlays:setOverlay(self, overlay["setting"], posX+horizontal, posY);
		if slotTable.setting.on then
			moSetGetOverlays:setBackgroundColor(overlay["setting"], moColors.intern["green"]);
		else
			moSetGetOverlays:setBackgroundColor(overlay["setting"], moColors.intern["darkGray"])
		end;
		overlay["setting"]:render();
		if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["setting"].x, overlay["setting"].x+overlay["setting"].width, overlay["setting"].y, overlay["setting"].y+overlay["setting"].height, "settingSlot", whichSubSLOT);end;
		--setting		
		--cmd
		moSetGetOverlays:setOverlay(self, overlay["buttonCmd"], posX+(horizontal*2), posY);
		if not slotTable.setting.cmdSelect then
			moSetGetOverlays:setBackgroundColor(overlay["buttonCmd"], moColors.intern["yellow"]);
		else
			moSetGetOverlays:setBackgroundColor(overlay["buttonCmd"], moColors.intern["green"]);
		end;
		overlay["buttonCmd"]:render();
		if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["buttonCmd"].x, overlay["buttonCmd"].x+overlay["buttonCmd"].width, overlay["buttonCmd"].y, overlay["buttonCmd"].y+overlay["buttonCmd"].height, "settingCmdSlot", whichSubSLOT);end;
		--cmd		
		--line border
		moDraw.mohSLOT:setLineBorder(self, overlay["line"], overlay["groundMaster"], 1, 0.0005, false, true, true, true, moColors.intern["black"]);
		--line border
		--save
		moSetGetOverlays:setOverlay(self, overlay["save"], posX+width-(horizontal), posY);
		if slotTable.save then moSetGetOverlays:setBackgroundColor(overlay["save"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["save"], moColors.intern["red"]);end;
		overlay["save"]:render();
		if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["save"].x, overlay["save"].x+overlay["save"].width, overlay["save"].y, overlay["save"].y+overlay["save"].height, "saveSlot", whichSubSLOT);end;
		--save
		--help
		moSetGetOverlays:setOverlay(self, overlay["help"], posX+width-(horizontal*2), posY);
		moSetGetOverlays:setBackgroundColor(overlay["help"], moColors.intern["yellow"]);
		overlay["help"]:render();
		if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["help"].x, overlay["help"].x+overlay["help"].width, overlay["help"].y, overlay["help"].y+overlay["help"].height, "visibleOwnHelpSlot", whichSubSLOT);end;
		--help			
	end;
	--setting Line
	
	--slotNameGround/move txt
	moSetGetOverlays:setOverlay(self, overlay["slotNameGround"], posX, posY+masterHeight-vertical, width, vertical);
	overlay["slotNameGround"]:render();
	moDraw.mohSLOT:setLineBorder(self, overlay["line"], overlay["slotNameGround"], 1, 0.0005, true, true, true, true, moColors.intern["black"]);	
	--slotNameGround/move text	
	--close
	moSetGetOverlays:setOverlay(self, overlay["close"], overlay["slotNameGround"].x+width-horizontal, overlay["slotNameGround"].y);
	overlay["close"]:render();
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["close"].x, overlay["close"].x+overlay["close"].width, overlay["close"].y, overlay["close"].y+overlay["close"].height, "closeSlot", whichSubSLOT);end;
	--close
	--smallView
	moSetGetOverlays:setOverlay(self, overlay["smallView"], overlay["slotNameGround"].x+width-(horizontal*2), overlay["slotNameGround"].y);	
	if not moSetGetOverlays.slot[whichSubSLOT].smallView then moSetGetOverlays:setBackgroundColor(overlay["smallView"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["smallView"], moColors.intern["darkGray"]);end;
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["smallView"].x, overlay["smallView"].x+overlay["smallView"].width, overlay["smallView"].y, overlay["smallView"].y+overlay["smallView"].height, "smallViewSlot", whichSubSLOT);end;
	overlay["smallView"]:render();
	--smallView
	--open setting line
	if slotTable.settingLine then
		moSetGetOverlays:setBackgroundColor(overlay["smallView"], moColors.intern["green"]);
	else
		moSetGetOverlays:setBackgroundColor(overlay["smallView"], moColors.intern["darkGray"]);
	end;
	moSetGetOverlays:setOverlay(self, overlay["buttonDown"], overlay["slotNameGround"].x+width-(horizontal*3), overlay["slotNameGround"].y);
	if slotTable.settingLine then
		moSetGetOverlays:setBackgroundColor(overlay["buttonDown"], moColors.intern["green"]);
	else
		moSetGetOverlays:setBackgroundColor(overlay["buttonDown"], moColors.intern["darkGray"]);
	end;
	if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["buttonDown"].x, overlay["buttonDown"].x+overlay["buttonDown"].width, overlay["buttonDown"].y, overlay["buttonDown"].y+overlay["buttonDown"].height, "settingLineSlot", whichSubSLOT);end;
	overlay["buttonDown"]:render();	
	--open setting line	
	--slot name txt and edit	
	txt = tostring(slotTable.name);		
	setTextColor(unpack(moColors.extern[slotTable.txtMarkerColor]));
	if slotTable.setting.on then
		moSetGetOverlays:setOverlay(self, overlay["txtEdit"], overlay["slotNameGround"].x, overlay["slotNameGround"].y);
		if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["txtEdit"].x, overlay["txtEdit"].x+overlay["txtEdit"].width, overlay["txtEdit"].y, overlay["txtEdit"].y+overlay["txtEdit"].height, "txtEditNameSlot", whichSubSLOT);end;
		if moSetGetExtras:runsTimer("1sec", true) then
			overlay["txtEdit"]:render();
			txt = "";
		end;
		setTextColor(unpack(moColors.intern["green"]));
	end;
	optiSize = moSetGetExtras:getWidthOptimalSize(width-(horizontal*2), txt, slotTable.size);
	setTextBold(true);	
	renderText(overlay["slotNameGround"].x+horizontalTxtDistance, overlay["slotNameGround"].y+verticalTxtDistance, optiSize, txt);
	setTextBold(false);
	setTextColor(1, 1, 1, 1);
	--slot name txt and edit
	if not moSetGetOverlays.slot[whichSubSLOT].smallView then
		--------------------------slave Ground--------------------------		
		moSetGetOverlays:setOverlay(self, overlay["groundLines"], posX, posY-height, width, vertical);
		moSetGetOverlays:setOverlay(self, overlay["groundSlave"], posX, posY-height, width, height);		
		overlay["groundSlave"]:render();
		if slotTable.settingLine then
			--slotHelp by lineTable
			moSetGetOverlays:setOverlay(self, overlay["help"], posX+width-(horizontal*3), posY);
			if slotTable.isLineHelp then moSetGetOverlays:setBackgroundColor(overlay["help"], moColors.intern["green"]);else moSetGetOverlays:setBackgroundColor(overlay["help"], moColors.intern["darkGray"]);end;
			overlay["help"]:render();
			if not disableClickArea then moDraw.mohSLOT:clickAreas(overlay["help"].x, overlay["help"].x+overlay["help"].width, overlay["help"].y, overlay["help"].y+overlay["help"].height, "slotLineHelp", whichSubSLOT);end;
			--slotHelp by lineTable
		end;
		--widthHeightZoom
		if not MultiOverlayV3.dragDropPos.on and overlay["widthHeightZoom"].visible and not moSetGetExtras:runsTimer("5sec") then overlay["widthHeightZoom"].visible = false;end;
		moSetGetOverlays:setOverlay(self, overlay["widthHeightZoom"], posX+width-(horizontal/1.5), overlay["groundSlave"].y-(vertical/2.5));
		overlay["widthHeightZoom"]:render();		
		if not MultiOverlayV3.dragDropPos.on or MultiOverlayV3.dragDropPos.whatDragDrop == whichSubSLOT then moDraw.mohSLOT:clickAreas(overlay["widthHeightZoom"].x, overlay["widthHeightZoom"].x+overlay["widthHeightZoom"].width, overlay["widthHeightZoom"].y, overlay["widthHeightZoom"].y+overlay["widthHeightZoom"].height, "widthHeightZoomSlot", whichSubSLOT);end;
		--widthHeightZoom
		--------------------------slave Ground--------------------------
		if not slotTable.setting.cmdSelect and slotTable.cmd ~= nil and #slotTable.cmd > 0 then
			local maxLines = 0;
			local acceptCmdTyp = moGeneralSettings.acceptCmdTyp;
			local cmdExecuted = 0;
			local nextCmd = 1;
			for cmd=1, #slotTable.cmd do				
				if slotTable.cmd[cmd] ~= nil then					
					local slotCmdTable = slotTable.cmd[cmd]					
					local getCmdName = slotCmdTable.name;
					local getCmdFrom = slotCmdTable.from;
					local getCmdFromRealName = slotCmdTable.fromRealName;
					local getCmdTable = moSetGetCmd:cmdFromReady(nil, getCmdName, getCmdFrom, getCmdFromRealName);					
					if getCmdTable ~= nil and string.find(acceptCmdTyp, getCmdTable.typ) and getCmdTable.typ == "output_" then						
						if not getCmdTable.multiple and cmdExecuted > 0 then return;end; --not multiple cmd, here stop
						if type(getCmdTable.action) == "function" then							
							local getOutputLineTable = getCmdTable.action(getCmdTable);							
							if getOutputLineTable ~= nil and type(getOutputLineTable) == "table" and #getOutputLineTable > 0 then
								if slotTable.output[nextCmd] == nil then slotTable.output[nextCmd] = {line={}};end;
								slotTable.output[nextCmd].line = getOutputLineTable;							
								maxLines = maxLines+#slotTable.output[nextCmd].line;
								cmdExecuted = cmdExecuted+1;
								nextCmd = nextCmd+1; --for old other Maps Cmds								
							end;
						end;						
					end;
				end;
			end;
			if cmdExecuted > 0 then				
				local outputTable = slotTable.output;
				slotTable.renderViewLines.bounds[3] = maxLines;
				moDraw.type:setOpenDraw_TypeNew( {posX=posX,posY=posY,height=height,width=width,txtHeight=txtHeight,size=size,overlay=overlay,outputTable=outputTable,slotTable=slotTable,horizontal=horizontal,horizontalTxtDistance=horizontalTxtDistance,vertical=vertical,verticalTxtDistance=verticalTxtDistance,masterHeight=masterHeight,disableClickArea=disableClickArea,whichSubSLOT=whichSubSLOT} )
			end;			
		elseif slotTable.setting.cmdSelect then
			slotOutputTables:loadSlotOutputCmd(whichSubSLOT);			
			slotTable.output = {};
			slotTable.output[1] = {line=slotTable.setting.output};			
			local outputTable = slotTable.output;				
			slotTable.renderViewLines.bounds[3] = #slotTable.output[1].line;			
			moDraw.type:setOpenDraw_TypeNew( {posX=posX,posY=posY,height=height,width=width,txtHeight=txtHeight,size=size,overlay=overlay,outputTable=outputTable,slotTable=slotTable,horizontal=horizontal,horizontalTxtDistance=horizontalTxtDistance,vertical=vertical,verticalTxtDistance=verticalTxtDistance,masterHeight=masterHeight,disableClickArea=disableClickArea,whichSubSLOT=whichSubSLOT} )
		end;
		if not disableClickArea then --scrollSlideUpDownSlot
			moDraw.mohSLOT:clickAreas(overlay["groundSlave"].x, overlay["groundSlave"].x+overlay["groundSlave"].width, overlay["groundSlave"].y, overlay["groundSlave"].y+overlay["groundSlave"].height, "scrollSlideUpDownSlot", whichSubSLOT);
		end;
	end;
	setTextBold(false);
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
end;


function moDraw.mohSLOT:clickAreas(posX, posX1, posY, posY1, whatClick, whereClick, line, position, callback, ownValues)
	local whichSubSLOT = whereClick or "masterSLOT_";
	moGeneralSettings.clickAreas.slot[whichSubSLOT][#moGeneralSettings.clickAreas.slot[whichSubSLOT]+1] = {
		posX;
		posX1;
		posY;
		posY1;
		whatClick = whatClick or "";
		line = line or 0;		
		position = position or 1;
		whereClick = whereClick or "";
		callback = callback or nil;
		ownValues = ownValues or nil;
	};
end;

function moDraw.mohSLOT:setLineBorder(self, line, referenceOverlay, length, fat, up, down, left, right, color, alignment)	
	if color ~= nil then moSetGetOverlays:setBackgroundColor(line, color);else moSetGetOverlays:setBackgroundColor(line,  moColors.intern["darkGray"]);end;	
	--line.debugEnabled = true;		
	local xPixel = 1 / g_screenWidth;
	local yPixel = 1 / g_screenHeight;
	local tempLengthW = xPixel*length;
	local tempLengthH = yPixel*length;
		--setOverlayColor(GuiElement.debugOverlay, 0, 0, 1, 1)
		--renderOverlay(GuiElement.debugOverlay, self.x + self.offsetX - xPixel, self.y + self.offsetY - yPixel, self.width + 2 * xPixel, yPixel)
		--renderOverlay(GuiElement.debugOverlay, self.x + self.offsetX - xPixel, self.y + self.offsetY + self.height, self.width + 2 * xPixel, yPixel)
		--renderOverlay(GuiElement.debugOverlay, self.x + self.offsetX - xPixel, self.y + self.offsetY, xPixel, self.height)
		--renderOverlay(GuiElement.debugOverlay, self.x + self.offsetX + self.width, self.y + self.offsetY, xPixel, self.height)
		--line:setAlignment(nil, 4)
		--ALIGN_VERTICAL_BOTTOM = 1
		--ALIGN_VERTICAL_MIDDLE = 2
		--ALIGN_VERTICAL_TOP = 3
		--ALIGN_HORIZONTAL_LEFT = 4
		--ALIGN_HORIZONTAL_CENTER = 5
		--ALIGN_HORIZONTAL_RIGHT = 6
	
	
	if up then 
		if alignment == nil or alignment == 0 then --left pos
			moSetGetOverlays:setOverlay(self, line, referenceOverlay.x, referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 1 then --middle pos
			moSetGetOverlays:setOverlay(self, line, referenceOverlay.x+(referenceOverlay.width/2)-((referenceOverlay.width/length-(fat/2))/2), referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 2 then --right pos
			moSetGetOverlays:setOverlay(self, line, referenceOverlay.xreferenceOverlay.width-(referenceOverlay.width/length-(fat/2)), referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		end;
		renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
	end;
	--line:render();end;	
	
	if down then 
		if alignment == nil or alignment == 0 then
			moSetGetOverlays:setOverlay(self, line, referenceOverlay.x, referenceOverlay.y-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 1 then
			moSetGetOverlays:setOverlay(self, line, referenceOverlay.x+(referenceOverlay.width/2)-(referenceOverlay.width/length-(fat/2)/2), referenceOverlay.y-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 2 then
			moSetGetOverlays:setOverlay(self, line, referenceOverlay.x+referenceOverlay.width-referenceOverlay.width/length-(fat/2), referenceOverlay.y-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		end;
		renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
	end;
	--line:render();end;	
		
	if left then moSetGetOverlays:setOverlay(self, line, referenceOverlay.x, referenceOverlay.y, fat, referenceOverlay.height/length);
	renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY, xPixel, line.height);end;
	--line:render();end;	
	
	if right then moSetGetOverlays:setOverlay(self, line, referenceOverlay.x+referenceOverlay.width, referenceOverlay.y, fat, referenceOverlay.height/length);
	renderOverlay(line.overlayId, line.x+line.offsetX-xPixel+line.width, line.y+line.offsetY, xPixel, line.height);end;
	--line:render();end;
end;

function moDraw.mohSLOT:setSlideRegulatorOverlay(self, overlay, slideOverlayTable, color)
	if color ~= nil then moSetGetOverlays:setBackgroundColor(overlay, color);else moSetGetOverlays:setBackgroundColor(overlay, moColors.intern["darkGray"]);end;  
	moSetGetOverlays:setOverlay(self, overlay, slideOverlayTable.x, slideOverlayTable.y, slideOverlayTable.width, slideOverlayTable.height);
	overlay:render();
end;

function moDraw.mohSLOT:setSlideButtonOverlay(self, referenceOverlay, upDown, color, whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local name1, name2 = "slideButtonLeft", "slideButtonRight";
	local vertical = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].height;
	local horizontal = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].width;
	if upDown then name1, name2 = "slideButtonUp", "slideButtonDown";end;
	local overlay1, overlay2 = moSetGetOverlays.slot[whichSubSLOT].design[name1], moSetGetOverlays.slot[whichSubSLOT].design[name2];
	if color ~= nil then moSetGetOverlays:setBackgroundColor(overlay1, color);moSetGetOverlays:setBackgroundColor(overlay2, color);else	moSetGetOverlays:setBackgroundColor(overlay1, moColors.intern["darkGray"]);moSetGetOverlays:setBackgroundColor(overlay2, moColors.intern["darkGray"]);end;  
	if upDown then
		moSetGetOverlays:setOverlay(self, overlay1, referenceOverlay.x, referenceOverlay.y+referenceOverlay.height-vertical, referenceOverlay.width, vertical);	
		moSetGetOverlays:setOverlay(self, overlay2, referenceOverlay.x, referenceOverlay.y, referenceOverlay.width, vertical);
	else
		moSetGetOverlays:setOverlay(self, overlay1, referenceOverlay.x, referenceOverlay.y, horizontal, referenceOverlay.height);	
		moSetGetOverlays:setOverlay(self, overlay2, referenceOverlay.x+referenceOverlay.width-horizontal, referenceOverlay.y, horizontal, referenceOverlay.height);	
	end;
	overlay1:render();
	overlay2:render();	
end;

function moDraw.mohSLOT:getSlideRegulatorOverlay(upDown, lineFat, whichSLOT) -- moDraw.mohSLOT:getSlideRegulatorOverlay(referenceOverlay, viewLines, bounds1, bounds2, maxLines, upDown, lineFat, distance, whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local referenceOverlay = moSetGetOverlays.slot[whichSubSLOT].design["slideLeftRightGround"];	  
	local bounds1 = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[1];
	local bounds2 = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[2];
	local viewLines = bounds2-bounds1-1;
	local maxLines = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[3]; 
	local lineFat = lineFat; 
	local distance = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].width*2;
	if upDown then	
	
	end;
	local slideTable = {};
	local widthOrHeight = 0;
	local oneLines = 0;
	local lineFat = lineFat or 0;
	local distance = distance or 0;
	if upDown then --upDown slide--
		widthOrHeight = (referenceOverlay.height-distance)/maxLines;		
		if widthOrHeight < 0.0003 then
			--widthOrHeight = 0.003;			
		end;
		oneLines = widthOrHeight;
		widthOrHeight = oneLines*viewLines;
	else--leftRight slide
		widthOrHeight = (referenceOverlay.width-distance)/maxLines;		
		if widthOrHeight < 0.0003 then
			widthOrHeight = 0.0003;			
		end;
		oneLines = widthOrHeight;
		widthOrHeight = oneLines*viewLines;
	end;
	if widthOrHeight and oneLines > 0 and upDown then ---upDown slide
		slideTable.width = referenceOverlay.width-(lineFat*2);
		slideTable.height = widthOrHeight;
		slideTable.x = referenceOverlay.x+(lineFat);
		local tempPosY = 0;
		if bounds1 == 1 then slideTable.y = referenceOverlay.y+(distance/2)+(referenceOverlay.height-distance)-widthOrHeight;
		elseif bounds2 == maxLines then slideTable.y = referenceOverlay.y+(distance/2);
		else			
			slideTable.y = referenceOverlay.y+(oneLines*bounds1);			
		end;
	elseif widthOrHeight and oneLines > 0 and not upDown then ---leftRight slide
		slideTable.height = referenceOverlay.height-(lineFat*2);		
		slideTable.width = widthOrHeight;		
		slideTable.y = referenceOverlay.y+(lineFat);
		local tempPosY = 0;
		if bounds1 == 1 then slideTable.x = referenceOverlay.x+(distance/2);
		elseif bounds2 == maxLines then slideTable.x = referenceOverlay.x+(distance/2)+(referenceOverlay.width-(distance))-widthOrHeight;
		else slideTable.x = referenceOverlay.x+(distance/2)+(oneLines*bounds1);end;		
	end;
	if upDown then
	else		
		if bounds2 - bounds1 >= maxLines-1 then moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[4] = false;else moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[4] = true;end;
	end;
	referenceOverlay.slideTable = slideTable
	return slideTable;
end;

